package com.example.test4;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import android.util.Base64;
import java.util.List;

public class AdapterMask extends BaseAdapter
{
    public Context mContext;
    List<Mask> maskList;

    public AdapterMask(Context mContext, List<Mask> maskList) {
        this.mContext = mContext;
        this.maskList = maskList;
    }

    @Override
    public int getCount() {
        return maskList.size();
    }

    @Override
    public Object getItem(int position) {
        return maskList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return maskList.get(position).getID();
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        View view = View.inflate(mContext, R.layout.item_mask, null);

        TextView title = view.findViewById(R.id.title);
        TextView cost = view.findViewById(R.id.cost);
        TextView stockAvailability = view.findViewById(R.id.stockAvailability);
        TextView availabilityInTheStore = view.findViewById(R.id.availabilityInTheStore);
        TextView description = view.findViewById(R.id.description);
        TextView rewiews = view.findViewById(R.id.rewiews);
        ImageView image = view.findViewById(R.id.image);
        TextView many = view.findViewById(R.id.many);

        Mask mask = maskList.get(position);
        title.setText(mask.getTitle());
        cost.setText(String.valueOf(mask.getCost()));
        stockAvailability.setText(String.valueOf(mask.getStockAvailability()));
        availabilityInTheStore.setText(String.valueOf(mask.getAvailabilityInTheStore()));
        description.setText(String.valueOf(mask.getDescription()));
        rewiews.setText(mask.getRewiews());
        if(mask.getImage() != null && !mask.getImage().equals(""))
        {
            image.setImageBitmap(stringToBitmap(mask.getImage()));
        }
        else
        {
            image.setImageResource(R.drawable.absence);
        }
        if(mask.getStockAvailability()>5)
        {
            many.setVisibility(View.VISIBLE);
        }
        return view;
    }

    private Bitmap stringToBitmap(String image) {
        if(image != null && !image.equals(""))
        {
            byte[] array = Base64.decode(image, Base64.DEFAULT);
            return BitmapFactory.decodeByteArray(array, 0 , array.length);
        }
        else
        {
            return null;
        }
    }
}
