package com.example.test4;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

public class MainActivity extends AppCompatActivity {

    public static int index;
    EditText search;
    Spinner spinner;
    Button btnAdd;
    TextView nameUser;

    AdapterMask adapterMask;
    List<Mask> maskList = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        ListView list = findViewById(R.id.list);
        adapterMask = new AdapterMask(this, maskList);
        list.setAdapter(adapterMask);

        nameUser = findViewById(R.id.nameUser);
        search = findViewById(R.id.search);
        search.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                new GetData().execute();
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        spinner = findViewById(R.id.order);
        spinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                new GetData().execute();
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        btnAdd = findViewById(R.id.add);
        if(Login.nameUser == "")
        {
            btnAdd.setVisibility(View.INVISIBLE);
            nameUser.setText("");
            list.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                }
            });
        }
        else
        {
            btnAdd.setVisibility(View.VISIBLE);
            nameUser.setText("Текущий пользователь: " + Login.nameUser);
            list.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                    index = (int)id;
                    startActivity(new Intent(MainActivity.this, Upd.class));
                }
            });
        }

        new GetData().execute();
    }

    public class GetData extends AsyncTask<Void, Void, String>
    {

        @Override
        protected String doInBackground(Void... voids) {
            try
            {
                URL url = new URL("11HatShops/sortByHatShops?typeOfSort=" + spinner.getSelectedItemId() +"&nameProduct=" + search.getText().toString());
                HttpURLConnection connection = (HttpURLConnection)url.openConnection();
                BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
                StringBuilder result = new StringBuilder();
                String line = "";
                while ((line = reader.readLine()) != null)
                {
                    result.append(line);
                }
                return result.toString();
            }
            catch (Exception exception)
            {
                return  null;
            }
        };

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            try {
                maskList.clear();
                adapterMask.notifyDataSetInvalidated();
                JSONArray jsonArray = new JSONArray(s);
                for(int i = 0; i < jsonArray.length(); i++)
                {
                    JSONObject jsonObject = jsonArray.getJSONObject(i);
                    Mask mask = new Mask(
                            jsonObject.getInt("ID"),
                            jsonObject.getString("Title"),
                            jsonObject.getInt("Cost"),
                            jsonObject.getInt("StockAvailability"),
                            jsonObject.getInt("AvailabilityInTheStore"),
                            jsonObject.getString("Description"),
                            jsonObject.getString("Rewiews"),
                            jsonObject.getString("Image")
                    );
                    maskList.add(mask);
                    adapterMask.notifyDataSetInvalidated();
                }
            }
            catch (Exception exception)
            {

            }
        }
    }

    public void back(View V)
    {
        startActivity(new Intent(this, Login.class));
    }

    public void add(View V)
    {
        startActivity(new Intent(this, Add.class));
    }
}