package com.example.test4;

import androidx.activity.result.ActivityResult;
import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.appcompat.app.AppCompatActivity;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.os.SystemClock;
import android.provider.MediaStore;
import android.util.Base64;
import android.util.JsonReader;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONObject;

import java.io.ByteArrayOutputStream;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;

public class Upd extends AppCompatActivity {

    EditText title, cost, stockAvailability, availabilityInTheStore, Description, Rewiews;
    String varcharImage;
    ImageView image;
    TextView deleteImage;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_upd);

        deleteImage = findViewById(R.id.deleteImage);
        image = findViewById(R.id.image);
        title = findViewById(R.id.title);
        cost = findViewById(R.id.Cost);
        stockAvailability = findViewById(R.id.StockAvailability);
        availabilityInTheStore = findViewById(R.id.AvailabilityInTheStore);
        Description = findViewById(R.id.Description);
        Rewiews = findViewById(R.id.Rewiews);
        getData();
    }

    ActivityResultLauncher<Intent> someActivityResultLauncher = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), new ActivityResultCallback<ActivityResult>() {
        @Override
        public void onActivityResult(ActivityResult result) {
            Bitmap bitmap = null;
            if(result.getResultCode() == Activity.RESULT_OK)
            {
                Uri selectedImage = result.getData().getData();
                try {
                    bitmap = MediaStore.Images.Media.getBitmap(getContentResolver(), selectedImage);
                }
                catch (Exception ex)
                {
                }
                image.setImageBitmap(null);
                image.setImageBitmap(bitmap);
                deleteImage.setVisibility(View.VISIBLE);
                varcharImage = BitmapToString(bitmap);
            }
        }
    });

    public String BitmapToString(Bitmap bitmap)
    {
        ByteArrayOutputStream boas = new ByteArrayOutputStream();
        bitmap.compress(Bitmap.CompressFormat.PNG, 100, boas);
        byte[] b = boas.toByteArray();
        String temp = Base64.encodeToString(b, Base64.DEFAULT);
        return temp;
    }

    private Bitmap stringToBitmap(String image) {
        if(image != null && !image.equals(""))
        {
            byte[] array = Base64.decode(image, Base64.DEFAULT);
            return BitmapFactory.decodeByteArray(array, 0 , array.length);
        }
        else
        {
            return null;
        }
    }

    public void getData()
    {
        Retrofit retrofit = new Retrofit.Builder()
                .baseUrl("https://ngknn.ru:5001/NGKNN/%D0%9C%D0%B0%D0%BC%D1%88%D0%B5%D0%B2%D0%B0%D0%AE%D0%A1/%D0%AD%D0%BA%D0%B7%D0%B0%D0%BC%D0%B5%D0%BD/api/")
                .addConverterFactory(GsonConverterFactory.create())
                .build();
        RetrofitAPI retrofitAPI = retrofit.create(RetrofitAPI.class);
        Call<HatShopsModal> call = retrofitAPI.getData(MainActivity.index);
        call.enqueue(new Callback<HatShopsModal>() {
            @Override
            public void onResponse(Call<HatShopsModal> call, Response<HatShopsModal> response) {
                if(!response.isSuccessful())
                {
                    Toast.makeText(Upd.this, "При выводе данных возникла ошибка", Toast.LENGTH_SHORT).show();
                }
                title.setText(response.body().getTitle());
                cost.setText(String.valueOf(response.body().getCost()));
                stockAvailability.setText(String.valueOf(response.body().getStockAvailability()));
                availabilityInTheStore.setText(String.valueOf(response.body().getAvailabilityInTheStore()));
                Description.setText(response.body().getDescription());
                Rewiews.setText(response.body().getDescription());
                if(!response.body().getImage().equals(""))
                {
                    varcharImage = response.body().getImage();
                    image.setImageBitmap(stringToBitmap(response.body().getImage()));
                    deleteImage.setVisibility(View.VISIBLE);
                }
                else {
                    image.setImageResource(R.drawable.absence);
                    deleteImage.setVisibility(View.INVISIBLE);
                    varcharImage = "";
                }
            }

            @Override
            public void onFailure(Call<HatShopsModal> call, Throwable t) {
                Toast.makeText(Upd.this, "При выводе данных возникла ошибка", Toast.LENGTH_SHORT).show();
            }
        });
    }

    public void updImage(View view)
    {
        Intent intent = new Intent(Intent.ACTION_PICK);
        intent.setType("image/*");
        someActivityResultLauncher.launch(intent);
    }

    public void deleteImage(View view)
    {
        varcharImage = "";
        deleteImage.setVisibility(View.INVISIBLE);
        image.setImageBitmap(null);
        image.setImageResource(R.drawable.absence);

    }

    public void back(View v)
    {
        startActivity(new Intent(this, MainActivity.class));
    }

    public void delete(View v)
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setTitle("Предупреждение");
        builder.setMessage("Вы уверены, что хотите удаить запись?");
        builder.setPositiveButton("Да", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                deleteData();
                dialog.dismiss();
            }
        });
        builder.setNegativeButton("Нет", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {

            }
        });
        AlertDialog alertDialog = builder.create();
        alertDialog.show();
    }

    public void deleteData()
    {
        Retrofit retrofit = new Retrofit.Builder()
                .baseUrl("https://ngknn.ru:5001/NGKNN/%D0%9C%D0%B0%D0%BC%D1%88%D0%B5%D0%B2%D0%B0%D0%AE%D0%A1/%D0%AD%D0%BA%D0%B7%D0%B0%D0%BC%D0%B5%D0%BD/api/")
                .addConverterFactory(GsonConverterFactory.create())
                .build();
        RetrofitAPI retrofitAPI = retrofit.create(RetrofitAPI.class);
        Call<Void> call = retrofitAPI.deleteData(MainActivity.index);
        call.enqueue(new Callback<Void>() {
            @Override
            public void onResponse(Call<Void> call, Response<Void> response) {
                if(!response.isSuccessful())
                {
                    Toast.makeText(Upd.this, "При удаление данных возникла ошибка", Toast.LENGTH_SHORT).show();
                }
                Toast.makeText(Upd.this, "Данные успешно удалены", Toast.LENGTH_SHORT).show();
                SystemClock.sleep(1000);
                startActivity(new Intent(Upd.this, MainActivity.class));
            }

            @Override
            public void onFailure(Call<Void> call, Throwable t) {
                Toast.makeText(null, "При удаление данных возникла ошибка", Toast.LENGTH_SHORT).show();
            }
        });
    }

    public void upd(View v)
    {
        putData();
    }

    public void putData()
    {
        Retrofit retrofit = new Retrofit.Builder()
                .baseUrl("https://ngknn.ru:5001/NGKNN/%D0%9C%D0%B0%D0%BC%D1%88%D0%B5%D0%B2%D0%B0%D0%AE%D0%A1/%D0%AD%D0%BA%D0%B7%D0%B0%D0%BC%D0%B5%D0%BD/api/")
                .addConverterFactory(GsonConverterFactory.create())
                .build();
        RetrofitAPI retrofitAPI = retrofit.create(RetrofitAPI.class);
        HatShopsModal model = new HatShopsModal(MainActivity.index, title.getText().toString(), Integer.valueOf(cost.getText().toString()), Integer.valueOf(stockAvailability.getText().toString()), Integer.valueOf(availabilityInTheStore.getText().toString()), Description.getText().toString(), Rewiews.getText().toString(), varcharImage);
        Call<HatShopsModal> call = retrofitAPI.putData(MainActivity.index, model);
        call.enqueue(new Callback<HatShopsModal>() {
            @Override
            public void onResponse(Call<HatShopsModal> call, Response<HatShopsModal> response) {
                if(!response.isSuccessful())
                {
                    Toast.makeText(Upd.this, "При обноавление данных возникла ошибка", Toast.LENGTH_SHORT).show();
                }
                Toast.makeText(Upd.this, "Данные успешно обнавлены", Toast.LENGTH_SHORT).show();
            }

            @Override
            public void onFailure(Call<HatShopsModal> call, Throwable t) {
                Toast.makeText(null, "При обноавление данных возникла ошибка", Toast.LENGTH_SHORT).show();
            }
        });
    }

}